﻿Imports DatasetOnly.NorthWindDts

Public Class frmDatasetOnly
   Private _TimeRanges As Integer() = New Integer() {99999, 1, 2, 3, 6, 9, 12}

   Private Sub frmNorthWind_Load(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Load
      cmbOrderRange.DataSource = _TimeRanges
      NorthWindDts.CheckedCategory.Persist(False)
      Me.AlignOnTop.NorthWindDts.Register(Me).DataFile("..\..\NorthWind.xml").Fill()
      AddHandler Me.FormClosing, NorthWindDts.HandleFormClosing
   End Sub


   Private Sub MenuItem_Click(ByVal sender As Object, ByVal e As EventArgs) _
         Handles ReloadToolStripMenuItem.Click, SaveToolStripMenuItem.Click, RunArtikelFormToolStripMenuItem.Click, TestToolStripMenuItem.Click, btAddProduct.Click, btCancelEdit.Click, btDelete.Click
      Select Case True
         Case sender Is ReloadToolStripMenuItem : NorthWindDts.Fill()

         Case sender Is SaveToolStripMenuItem : NorthWindDts.Save(Me)

         Case sender Is RunArtikelFormToolStripMenuItem
            Using frm = New frmArtikels
               frm.ShowDialog(Me)
            End Using

         Case sender Is TestToolStripMenuItem
            KundenDataGridView.FirstDisplayedCell = KundenDataGridView(0, 3)
            'srcKategorieArtikel.Position = 2
            'colArtikelID.DisplayStyle = DataGridViewComboBoxDisplayStyle.Nothing
            'srcKategorieArtikel.MoveTo(srcKategorieArtikel.At(2))
            'CheckChanges(NorthWindDts)

         Case sender Is btAddProduct
            With srcKategorieArtikel.AddNewX(Of ArtikelRow)()
               .LieferantenID = 1
            End With

         Case sender Is btCancelEdit : srcKategorieArtikel.CancelEdit()

         Case sender Is btDelete : srcKategorieArtikel.RemoveCurrent()

      End Select
   End Sub

   Private Sub SetOrderFilter()
      If cmbOrderRange.SelectedIndex < 0 Then Return
      Dim n = _TimeRanges(cmbOrderRange.SelectedIndex)
      Dim filter = ""
      Try
         Dim rwBest = srcKundeBestellung.At(Of BestellungenRow)(0)
         If rwBest.Null Then Return
         Dim dt = rwBest.Bestelldatum
         If Date.MinValue.AddMonths(n) > dt Then
            Exit Sub 'die nachfolgende Rechnung ergäbe einen Wert < Minvalue - Fehler
         End If
         filter = "Bestelldatum > ".And("'", dt.AddMonths(-n).ToShortDateString, "'")
      Finally
         srcKundeBestellung.Filter = filter
         lbFilter.Text = filter
      End Try
   End Sub

   Private Sub Something_Changed(ByVal sender As Object, ByVal e As EventArgs) Handles cmbOrderRange.SelectedIndexChanged, srcKunden.PositionChanged
      SetOrderFilter()
   End Sub

   Private Sub KategorienDataGridView_CellContentClick(ByVal sender As Object, ByVal e As DataGridViewCellEventArgs) Handles KategorienDataGridView.CellContentClick
      If e.ColumnIndex <> 0 Then Return
      Dim cat = KategorienSource.At(Of KategorienRow)(e.RowIndex)
      If cat.Null Then Return
      ToggleCatChecked(cat)
   End Sub

   Private Sub ToggleCatChecked(ByVal cat As KategorienRow)
      Dim value = Not cat.Checked
      If value Then
         NorthWindDts.CheckedCategory.AddCheckedCategoryRow(cat)
      Else
         cat.GetCheckedCategoryRows.First.Delete()
      End If
   End Sub

End Class