﻿
Namespace System.Data

   ''' <summary>
   ''' speichert eine Datacolumn, und ihre gequoteten Schreibweisen, und auch eine Expression: das kann eine in Sql formulierte Bedingung für diese Column sein.
   ''' </summary>
   Public Class ColumnInfo
      Public Col As DataColumn
      Public ColName, TableName, Expression As String

      Public Function RenameTable(ByVal newName As String) As String
         RenameTable = TableName.And(" AS ", newName)
         TableName = newName
      End Function
      Public Function Fullname() As String
         Return ".".Between(TableName, ColName)
      End Function
      Public Sub New(ByVal col As DataColumn, ByVal xpr As String, Optional ByVal quote As Func(Of String, String) = Nothing)
         Me.Col = col
         If quote Is Nothing Then quote = col.Table.DataSet.Adapter.Quote
         ColName = quote(col.ColumnName)
         TableName = quote(col.Table.TableName)
         Expression = xpr
      End Sub
   End Class

End Namespace
