﻿Imports System.Runtime.CompilerServices
Imports System.Data.Common
Imports System.Reflection
Imports System.ComponentModel
Imports System.Windows.Forms
Imports System.Text.RegularExpressions

Namespace System.Data

   Public Module DatasetX
      ''' <summary>
      ''' get the manager of all Tables, TableAdapters and BindingSources and stuff
      ''' </summary>
      <DebuggerStepThrough()> _
      <Extension()> _
      Friend Function Adapter(ByVal dts As DataSet) As DatasetAdapter
         Return DirectCast(DatasetAdapterBase.Attachs(dts), DatasetAdapter)
      End Function
      ''' <summary>
      ''' sets the manager of all Tables, TableAdapters and BindingSources and stuff
      ''' </summary>
      <Extension()> _
      Public Function Adapter(ByVal dts As DataSet, ByVal value As DatasetAdapter) As DataSet
         Dim adp = dts.Adapter
         If adp.NotNull Then
            If adp Is value Then Return dts
            Throw value.Exception("Dataset.Adapter already initialized")
         End If
         value.DataSet = dts
         DatasetAdapterBase.Attachs(dts) = value
         Return dts
      End Function
      ''' <summary>the connection, for communication: dataset - database</summary>
      <DebuggerStepThrough()> _
      <Extension()> _
      Public Function Connection(ByVal dts As DataSet) As DbConnection
         Return dts.Adapter.Connection
      End Function
      <Extension()> _
      Public Sub Fill(ByVal tb As DataTable)
         tb.Fill("")
      End Sub
      ''' <summary>fills the table, applying additional conditions</summary>
      <Extension()> _
      Public Sub Fill(ByVal tb As DataTable, ByVal conditions As String, ByVal ParamArray values As Object())
         With tb.DataSet.Adapter
            .AddFillJobs(NewArray(.Adapters(tb).Fill(conditions, values, True, False)))
         End With
      End Sub
      ''' <summary>
      ''' fills child- and  child-child-tables of parentRow, applying additional
      ''' sql, eg. filter-clauses and stuff 
      ''' </summary>
      <Extension()> _
      Public Sub FillChildTables(ByVal parentRow As DataRow, ByVal tables As DataTable(), ByVal conditions As String, ByVal ParamArray values() As Object)
         With parentRow.Table.DataSet.Adapter
            .AddFillJobs(From tb In tables _
               Select .Adapters(tb).FillByParentRow(parentRow, conditions, values))
         End With
      End Sub
      ''' <summary>
      ''' fills the childTables of parentRow with associated records. also supports
      ''' filling child-child-tables
      ''' </summary>
      <Extension()> _
      Public Sub FillChildTables(ByVal parentRow As DataRow, ByVal ParamArray tables As DataTable())
         FillChildTables(parentRow, tables, "", New Object() {})
      End Sub
      ''' <summary>
      ''' fills a childTable of parentRow, applying additionalsql, eg. filter-clauses</summary>
      <Extension()> _
      Public Sub FillChildTable(ByVal parentRow As DataRow, ByVal table As DataTable, ByVal conditions As String, ByVal ParamArray values() As Object)
         FillChildTables(parentRow, NewArray(table), conditions, values)
      End Sub

   End Module

End Namespace
