﻿Imports System.Data.Common
Namespace System.Data
   Partial Class TableAdapter
      ''' <summary>stores a well preparated Fill-Command and can execute it. Nothing as command will not be executed (no exception)</summary>
      <DebuggerDisplay("{Adapter.Table.TableName}")> _
      Friend Class FillJob : Implements IComparable

         Public Adapter As TableAdapter, Command As DbCommand, ClearBeforeFill As Boolean
         Public Sub New(ByVal adp As TableAdapter)
            MyClass.New(adp, adp.AllCommands.FirstOrDefault, True)
         End Sub
         Public Sub New(ByVal adp As TableAdapter, ByVal cmd As DbCommand, ByVal clearBeforeFill As Boolean)
            Adapter = adp
            If cmd.Null Then Return
            Me.ClearBeforeFill = clearBeforeFill
            Command = cmd.Clone
         End Sub
         Public Sub Execute()
            If Command.Null Then Return
            Adapter.FillCore(Command, ClearBeforeFill)
            Command.Dispose()
         End Sub

         Public Function CompareTo(ByVal other As Object) As Integer Implements System.IComparable.CompareTo
            Return Adapter.Rank.CompareTo(DirectCast(other, FillJob).Adapter.Rank)
         End Function

      End Class

   End Class

End Namespace