﻿Imports System.Runtime.CompilerServices
Imports System.ComponentModel
Imports System.Data.Common
Imports System.Text
Imports System.Collections.ObjectModel

#Region "NoCompile"
#If NoCompile Then
um einen InnerJoin zu generieren brauchts nur die PrimColumn der übergeordneten und die ForeignKey-Column der untergeordneten Table. Kurz: Die DataRelation zw. den beiden. Minimum: die ForeignKey-Column, denn damit läßt sich die DataRelation finden.
Joiner ist nun eine Liste of ColumnInfo-Pärchen (also DataRelations)
Zum Sql generieren wird ein Joining-Plan erstellt, der die Pärchen richtig anordnet.
Es muß immer eine Table gefunden werden, die im plan bereits vorhanden ist - dann kann die annere Table drangejoint werden.
Ist die annere auch schon vorhanden, so liegt ein Self-Join vor, und sie muß renamed werden.
Angenommen die Relationen Kunde->Bestellung, Bearbeiter->Bestellung, Bestellung->BestellDetail.
Dann nimmt der Plan die erste Relation auf, und sucht dann eine Relation, deren eine Table im Plan bekannt ist. Die bekannte Table wird jeweils nach hinten geräumt, also:  Kunde->Bestellung, Bearbeiter->Bestellung, BestellDetail<-Bestellung und dann wird losgeneriert:
(Randwert: Bestellung) INNER JOIN Kunde ON Kunde.ID=Bestellung.KundeID INNER JOIN Bearbeiter ON Bearbeiter.ID=Bestellung.BearbeiterID INNER JOIN BestellDetail ON BestellDetail.BestellungID=Bestellung.ID
Als Verfeinerung Expressions: Bedingungen, die auf die Table der Column, der sie zugeordnet sind, anzuwenden sind. Etwa:
Bestellung INNER JOIN Kunde ON (Kunde.ID = ? AND Kunde.ID=Bestellung.KundeID) INNER JOIN Bearbeiter ON (Bearbeiter.ID = ? AND Bearbeiter.ID=Bestellung.BearbeiterID) INNER JOIN BestellDetail ON BestellDetail.BestellungID=Bestellung.ID
Das könnten etwa alle BestellDetails der Bestellungen eines Kunden sein, von einem Bearbeiter betreut.
#End If
#End Region 'NoCompile
Namespace System.Data

   Public Class Joiner : Inherits Collection(Of ColumnInfo())
      Private _Quote As Func(Of String, String)

      Public Function SelfJoin(ByVal colChild As DataColumn, Optional ByVal xpr1 As String = "") As Joiner
         ' mit einem Self-Join kann über m:n die Zutreffen mehrerer Kategorien abfragen (logic-AND). Über den m-ForeignKey joint die mittlerTable sich selbst - das ergibt wieder sich selbst. Nun wird aber das Zusatz-Kriterium gestellt, dass der n-ForeignKey einen bestimmten wert aufweisen soll. Dadurch werden alle Zuordnungen zw. m und n gefunden. (Das ginge zunächstmal auch mit einer einfachen WHERE-Klausel, aber) bei  Self-Joins kann man das Ergebnis wieder self-joinen und jeweils über ein weiteres n-Kriterium weiter einschränken.
         MyBase.Add(NewArray( _
            New ColumnInfo(colChild, "", _Quote), _
            New ColumnInfo(colChild, xpr1, _Quote)))
         Return Me
      End Function
      Public Shadows Function Add(ByVal colChild As DataColumn, Optional ByVal xpr1 As String = "") As Joiner
         Me.Add("", colChild, xpr1)
         Return Me
      End Function
      Public Shadows Function Add(ByVal rl As DataRelation, Optional ByVal xpr1 As String = "") As Joiner
         Me.Add("", rl, xpr1)
         Return Me
      End Function
      Public Shadows Function Add(ByVal xpr0 As String, ByVal colChild As DataColumn, Optional ByVal xpr1 As String = "") As Joiner
         Dim rl = colChild.Table.ParentRelations.Cast(Of DataRelation) _
            .First(Function(r) r.ChildColumns(0) Is colChild)
         Me.Add(xpr0, rl, xpr1)
         Return Me
      End Function
      Public Shadows Function Add(ByVal xpr0 As String, ByVal rl As DataRelation, Optional ByVal xpr1 As String = "") As Joiner
         MyBase.Add(NewArray( _
            New ColumnInfo(rl.ParentColumns(0), xpr0, _Quote), _
            New ColumnInfo(rl.ChildColumns(0), xpr1, _Quote)))
         Return Me
      End Function

      Private Function CanConnect(ByVal itm As ColumnInfo(), ByVal plan As List(Of ColumnInfo())) As Boolean
         For i = 0 To 1
            Dim lookFor = itm(0).Col.Table
            For ii = 0 To 1
               For Each x In plan
                  If x(ii).Col.Table Is lookFor Then Return True
               Next
            Next
            itm.Swap(0, 1)
         Next
         Return False
      End Function

      Public Sub New(Optional ByVal quote As Func(Of String, String) = Nothing)
         _Quote = quote
      End Sub


      Public Function Sql() As String
         'verbindung suchen, jede Expression einarbeiten. Die Tabelle, die nicht verbindet, dranjoinen - dabei renamen falls bereits vorhanden (self-join).
         If Count = 0 Then Return ""
         Dim plan = NewList1(Me.Pop)
         While Count > 0
            For i = Count - 1 To 0 Step -1
               If CanConnect(Me(i), plan) Then
                  plan.Add(Me(i))
                  Me.RemoveAt(i)
               End If
            Next
         End While
         Dim joinInfo = plan(0)
         Dim knownClmns As New HashSet(Of String)
         Dim sb = New StringBuilder(New String("("c, plan.Count))
         knownClmns.Add(joinInfo(0).TableName)
         sb.Add(joinInfo(0).TableName)
         Dim counter As Counter = 0
         For Each joinInfo In plan
            Dim sTable = joinInfo(1).TableName
            If Not knownClmns.Add(sTable) Then sTable = joinInfo(1).RenameTable("X" & counter.Up)
            sb.Add(" INNER JOIN ", sTable, " ON (")
            For Each colInf In joinInfo.Where(Function(ci) ci.Expression.HasValue)
               sb.Add(colInf.TableName, ".", colInf.Expression, " AND ")
            Next
            sb.Add(joinInfo(0).Fullname, "=", joinInfo(1).Fullname, "))") 'Columns joinen
         Next
         Return sb.ToString
      End Function

   End Class

End Namespace
