﻿Imports System.Runtime.CompilerServices

Namespace System.Collections.Generic
   <HideModuleName()> _
   Public Module CollectionX

      Public Delegate Function GetChilds(Of T)(ByVal item As T) As IEnumerable

#Region "ICollection(ohne T)"

      <Extension()> _
      Public Function ToArray(Of T)(ByVal subj As System.Collections.ICollection) As T()
         ReDim ToArray(subj.Count - 1)
         If subj.Count > 0 Then subj.CopyTo(ToArray, 0)
      End Function

      <Extension()> _
      Public Sub ReplaceBy(Of T)(ByVal subj As ICollection(Of T), ByVal other As IEnumerable(Of T))
         subj.Clear()
         other.ForEach(AddressOf subj.Add)
      End Sub

#End Region 'ICollection(ohne T)

#Region "Array"

      <Extension()> _
      Public Function Clone(Of T)(ByVal subj As T()) As T()
         ReDim Clone(subj.Length - 1)
         Array.Copy(subj, Clone, subj.Length - 1)
      End Function

      <Extension()> _
      Public Sub CopyX(Of T)(ByVal Arr1() As T, ByVal Indx1 As Integer, ByVal Arr2() As T, ByVal Indx2 As Integer, ByVal Length As Integer)
         Array.Copy(Arr1, Indx1, Arr2, Indx2, Length)
      End Sub

      <Extension()> _
      Public Sub CopyX(Of T)(ByVal Arr1() As T, ByVal Arr2() As T, ByVal Indx2 As Integer, ByVal Length As Integer)
         Array.Copy(Arr1, 0, Arr2, Indx2, Length)
      End Sub

      <Extension()> _
      Public Sub CopyX(Of T)(ByVal Arr1() As T, ByVal Arr2() As T, ByVal Indx2 As Integer)
         Array.Copy(Arr1, 0, Arr2, Indx2, Arr1.Length)
      End Sub

      <Extension()> _
      Public Function FindIndex(Of T)(ByVal Arr() As T, ByVal IsMatch As Predicate(Of T)) As Integer
         Return Array.FindIndex(Arr, IsMatch)
      End Function

      <Extension()> _
      Public Function Find(Of T)(ByVal Arr() As T, ByVal IsMatch As Predicate(Of T)) As T
         Return Array.Find(Arr, IsMatch)
      End Function

      <Extension()> _
      Public Function IndexOf(Of T)(ByVal Arr() As T, ByVal Element As T) As Integer
         Return Array.IndexOf(Arr, Element)
      End Function

      <Extension()> _
      Public Function Contains(Of T)(ByVal Arr() As T, ByVal Element As T) As Boolean
         Return DirectCast(Arr, IList(Of T)).Contains(Element)
      End Function

      <Extension()> _
      Public Function ConvertAll(Of TSrc, TDest)( _
              ByVal Arr() As TSrc, ByVal Converter As Converter(Of TSrc, TDest)) As TDest()
         Return Array.ConvertAll(Arr, Converter)
      End Function

      <Extension()> _
      Public Sub KeepOnly(Of T)(ByRef subj() As T, ByVal predicate As Predicate(Of T))
         Dim i = subj.CloseUp(predicate)
         Dim newArr(i - 1) As T
         Array.Copy(subj, newArr, i)
         subj = newArr
      End Sub

      <Extension()> _
      Public Sub Sort(Of T)(ByVal subj() As T)
         Array.Sort(subj)
      End Sub

#End Region 'Array

#Region "IList"

      <Extension(), DebuggerStepThrough()> _
      Public Function AddPeek(Of T, T2 As T)(ByVal subj As ICollection(Of T), ByVal itm As T2) As T2
         subj.Add(itm)
         Return itm
      End Function

      ''' <summary>Bsp: vorletztes Element: list.Peek(-1)</summary>
      <Extension(), DebuggerStepThrough()> _
      Public Function Peek(Of T)(ByVal subj As IList(Of T), Optional ByVal index As Integer = 0) As T
         Return subj(index + subj.Count - 1)
      End Function
      ''' <summary>Bsp: setze vorletztes Element: list.Poke(-1, "huhu")</summary>
      <Extension(), DebuggerStepThrough()> _
      Public Sub Poke(Of T)(ByVal subj As IList(Of T), ByVal value As T, Optional ByVal index As Integer = 0)
         subj(index + subj.Count - 1) = value
      End Sub

      <Extension(), DebuggerStepThrough()> _
      Public Function Pop(Of T)(ByVal Subj As IList(Of T)) As T
         Dim i = Subj.Count - 1
         Pop = Subj(I)
         Subj.RemoveAt(I)
      End Function

      <Extension(), DebuggerStepThrough()> _
      Public Function PopAndPeek(Of T)(ByVal Subj As IList(Of T)) As T
         Dim i = Subj.Count - 1
         Subj.RemoveAt(i)
         Return Subj(i - 1)
      End Function

      <Extension(), DebuggerStepThrough()> _
      Public Sub Swap(ByVal Subj As IList, ByVal I1 As Integer, ByVal I2 As Integer)
         Dim Tmp = Subj(I1)
         Subj(I1) = Subj(I2)
         Subj(I2) = Tmp
      End Sub

      ''' <summary>returnt die Einfügeposition des items in die asc-sortierte Liste </summary>
      <Extension()> _
      Public Function InsertPosition(Of T As IComparable)( _
            ByVal subj As List(Of T), ByVal item As T) As Integer
         InsertPosition = subj.BinarySearch(item)
         If InsertPosition < 0 Then InsertPosition = InsertPosition Xor -1
      End Function

#End Region 'IList

#Region "Dictionary(Of T, T2)"

      <Extension()> _
      Public Function GetOrCreate(Of Tkey, Tvalue As New)( _
            ByVal subj As Dictionary(Of Tkey, Tvalue), ByVal key As Tkey) As Tvalue
         Dim ret As Tvalue
         If Not subj.TryGetValue(key, ret) Then
            ret = New Tvalue
            subj.Add(key, ret)
         End If
         Return ret
      End Function

      <Extension()> _
      Public Function GetOrDefault(Of Tkey, Tvalue)( _
            ByVal subj As Dictionary(Of Tkey, Tvalue), ByVal key As Tkey, ByVal [default] As Tvalue) As Tvalue
         If subj.TryGetValue(key, GetOrDefault) Then Exit Function
         Return [default]
      End Function

#End Region 'Dictionary(Of T, T2)

#Region "Enumerable"

      <DebuggerStepThrough()> _
      <Extension()> _
      Public Function Yield(Of T)(ByVal subj As IEnumerator(Of T)) As T
         subj.MoveNext()
         Return subj.Current
      End Function
      <DebuggerStepThrough()> _
      <Extension()> _
      Public Function Yield(ByVal subj As IEnumerator) As Object
         subj.MoveNext()
         Return subj.Current
      End Function

      <Extension()> _
      Public Function ToArray(Of T)(ByVal subj As IEnumerable) As T()
         Return subj.Cast(Of T).ToArray
      End Function

      <Extension()> _
      Public Function EachEquals(Of T As IEquatable(Of T))( _
            ByVal subj As IEnumerable(Of T), ByVal other As IEnumerable(Of T)) As Boolean
         Using e1 = subj.GetEnumerator, e2 = other.GetEnumerator
            Do
               If e1.MoveNext Then
                  If Not e2.MoveNext Then Return False 'e2 kürzer als e1
                  If Not e1.Current.Equals(e2.Current) Then Return False
                  Continue Do
               Else
                  Return Not e2.MoveNext 'returnt false, wenn e2 länger als e1
               End If
            Loop
         End Using
      End Function

      Public Structure MinMax(Of T)
         Public ReadOnly Min As T
         Public ReadOnly Max As T
         Public Sub New(ByVal Min As T, ByVal Max As T)
            Me.Min = Min : Me.Max = Max
         End Sub
      End Structure

      <Extension()> _
      Public Function Extremum(Of T, T2 As IComparable)(ByVal Subj As IEnumerable(Of T), ByVal Converter As Func(Of T, T2)) As MinMax(Of T)
         With Subj.GetEnumerator
            If Not .MoveNext Then Throw New ArgumentException( _
               "In leerer Auflistung kann kein Extremum gefunden werden")
            Dim MinMax = New T() {.Current, .Current}
            Dim Val = Converter(.Current)
            Dim Values = New T2() {Val, Val}
            While .MoveNext
               Val = Converter(.Current)
               If Val.CompareTo(Values(0)) < 0 Then
                  MinMax(0) = .Current
                  Values(0) = Val
               ElseIf Val.CompareTo(Values(1)) > 0 Then
                  MinMax(1) = .Current
                  Values(1) = Val
               End If
            End While
            Return New MinMax(Of T)(MinMax(0), MinMax(1))
            .Dispose()
         End With
      End Function

      <Extension()> _
      Public Function AllChilds(Of T)( _
            ByVal GetChilds As Func(Of T, IEnumerable), _
            ByVal Roots As IEnumerable) As IEnumerable(Of T)
         Dim Enumerate As Func(Of IEnumerable(Of T), IEnumerable(Of T)) = Nothing
         Enumerate = Function(enmbl) enmbl.Concat(enmbl.SelectMany(Function(nd) Enumerate(GetChilds(nd).Cast(Of T))))
         Return Enumerate(Roots.Cast(Of T))
      End Function

      <Extension()> _
      Public Function All(Of T)( _
            ByVal GetChilds As Func(Of T, IEnumerable), ByVal Root As T) As IEnumerable(Of T)
         'Root wird in die Enumeration hineingenommen, indem ein es enthaltendes IEnumerable(Of T) 
         'geschaffen wird, dessen Kinder ( = nur Root ) rekursiv enumeriert werden
         Return GetChilds.AllChilds(New T() {Root})
      End Function

      ''' <summary>returnt das Ergebnis einer Breitensuche</summary>
      <Extension()> _
      Public Function AllAsList(Of T)(ByVal getChilds As GetChilds(Of T), ByVal Roots As IEnumerable) As List(Of T)
         Dim ret As New List(Of T)
         For Each child As T In Roots : ret.Add(child) : Next
         Dim i As Integer = 0
         While i < ret.Count
            For Each child As T In getChilds(ret(i)) : ret.Add(child) : Next
            i += 1
         End While
         Return ret
      End Function

      <Extension()> _
      Public Function AllAsList(Of T)(ByVal getChilds As GetChilds(Of T), ByVal Root As T) As List(Of T)
         Return getChilds.AllAsList(New T() {Root})
      End Function

      <Extension()> _
      Public Function DisposeAll(Of T As IDisposable)(ByVal Subj As IList(Of T)) As IList(Of T)
         For Each itm As T In Subj
            If itm IsNot Nothing Then itm.Dispose()
         Next
         If Not Subj.IsReadOnly Then Subj.Clear()
         Return Subj
      End Function

      <Extension()> _
      Public Sub DisposeAll(Of T As IDisposable)(ByVal Subj As IEnumerable(Of T))
         For Each itm As T In Subj
            If itm IsNot Nothing Then itm.Dispose()
         Next
      End Sub

      <Extension()> _
      Public Function IndexOf(Of T)(ByVal Subj As IEnumerable(Of T), ByVal predicate As Func(Of T, Boolean)) As Integer
         For Each itm In Subj
            If predicate(itm) Then Exit Function
            IndexOf += 1
         Next
         Return -1
      End Function

      <Extension()> _
      Public Function IndexOf(Of T)(ByVal Subj As IList, ByVal predicate As Func(Of T, Boolean)) As Integer
         For Each itm As T In Subj
            If predicate(itm) Then Exit Function
            IndexOf += 1
         Next
         Return -1
      End Function

      <Extension()> _
      Public Sub ForEach(Of T)(ByVal Subj As IEnumerable, ByVal Action As Action(Of T))
         For Each itm As T In Subj
            Action(itm)
         Next
      End Sub

      <Extension()> _
      Public Sub ForEach(Of T)(ByVal Subj As IEnumerable(Of T), ByVal Action As Action(Of T))
         For Each itm In Subj
            Action(itm)
         Next
      End Sub

      <Extension()> _
      Public Function Except(Of T)(ByVal Subj As IEnumerable(Of T), ByVal item As T) As IEnumerable(Of T)
         Return Subj.Except(New T() {item})
      End Function

#End Region 'Enumerable

#Region "Helpers"

      <Extension()> _
      Private Function CloseUp(Of T)(ByVal subj As IList(Of T), ByVal predicate As Predicate(Of T)) As Integer
         Dim i As Integer
         For i = 0 To subj.Count - 1
            If Not predicate(subj(i)) Then Exit For
         Next
         For ii As Integer = i + 1 To subj.Count - 1
            If predicate(subj(ii)) Then
               subj(i) = subj(ii)
               i += 1
            End If
         Next
         Return i
      End Function

#End Region 'Helpers

   End Module

End Namespace
