﻿Namespace System

   ''' <summary> generische Exception mit genauen Daten über das fehler-werfende Objekt </summary>
   Public Class Exception(Of T) : Inherits System.Exception

      ''' <summary>
      ''' stellt den Fehler-Werfer fürs Debuggen zur Verfügung
      ''' </summary>
      Public ReadOnly Sender As T

      Public Sub New(ByVal sender As T, ByVal innerException As Exception, ByVal message As String)
         MyBase.New(String.Concat( _
            GetType(T).Name, "-Exception", _
            If(String.IsNullOrEmpty(message), "", ": " & Environment.NewLine & message)), innerException)
         Me.Sender = sender
#If DEBUG Then
         'If System.Windows.Forms.Application.OpenForms.Count = 0 Then Stop
#End If
      End Sub

   End Class

End Namespace
