﻿Imports System.Runtime.CompilerServices
Imports System.Diagnostics
Imports System.Reflection

Namespace System

   Public Module ObjectX

      <DebuggerStepThrough()> _
      <Extension()> _
      Public Function GetValue(ByVal prp As PropertyInfo, ByVal Obj As Object) As Object
         Return prp.GetValue(Obj, Nothing)
      End Function
      <DebuggerStepThrough()> _
      <Extension()> _
      Public Sub SetValue(ByVal prp As PropertyInfo, ByVal Obj As Object, ByVal value As Object)
         prp.SetValue(Obj, value, Nothing)
      End Sub
      <DebuggerStepThrough()> _
      <Extension()> _
      Public Function CastX(Of T)(ByVal Obj As Object) As T
         Return DirectCast(Obj, T)
      End Function
      <DebuggerStepThrough()> _
      <Extension()> _
      Public Function TryCastX(Of T As Class)(ByVal Obj As Object) As T
         Return TryCast(Obj, T)
      End Function

      <DebuggerStepThrough()> _
      <Extension()> _
      Public Function CloneX(Of T As ICloneable)(ByVal Obj As T) As T
         Return DirectCast(Obj.Clone(), T)
      End Function

      ''' <summary>returns the subject itself. Useful in With-Blocks</summary>
      <DebuggerStepThrough()> _
      <Extension()> _
      Public Function Self(Of T)(ByVal subj As T) As T
         Return subj
      End Function

      <Extension()> _
      Public Function NullSafe(Of T As Class)(ByVal subj As T, ByVal prop As String) As String
         If subj Is Nothing Then Return "--"
         Dim dsc = GetType(T).GetProperty(prop)
         Return dsc.GetValue(subj, Nothing).ToString
      End Function

      <Extension()> _
      Public Function Exception(Of T)(ByVal sender As T, ByVal firstMsgSegment As Object, ByVal ParamArray msgSegments As Object()) As Exception(Of T)
         Return Exception(Of T)(sender, Nothing, firstMsgSegment, String.Concat(msgSegments))
      End Function

      <Extension()> _
      Public Function Exception(Of T)(ByVal sender As T, ByVal innerException As Exception, ByVal ParamArray msgSegments As Object()) As Exception(Of T)
         Return New Exception(Of T)(sender, innerException, String.Concat(msgSegments))
      End Function

      <Extension()> _
      Public Function Exception(Of T)(ByVal sender As T) As Exception(Of T)
         Return Exception(Of T)(sender, Nothing)
      End Function

      ''' <summary> testet vor einer Zuweisung, ob der neue Wert überhaupt eine Änderung bringt </summary>
      ''' <remarks>
      ''' nützlich bei Zuweisungen an performance-intensive Properties, 
      ''' oder wenn auf Änderungen reagiert werden muß
      ''' </remarks>
      <Extension()> _
      Public Function Assign(Of T)(ByRef Dest As T, ByVal Src As T) As Boolean
         If Object.Equals(Dest, Src) Then Return False
         Dest = Src
         Return True
      End Function

      <DebuggerStepThrough()> _
      <Extension()> _
      Public Function Null(Of T As Class)(ByVal Subj As T) As Boolean
         Return Subj Is Nothing
      End Function

      <DebuggerStepThrough()> _
      <Extension()> _
      Public Function NotNull(Of T As Class)(ByVal Subj As T) As Boolean
         Return Subj IsNot Nothing
      End Function

   End Module
End Namespace
