﻿Namespace System

   Public Module modCreators

      Public Function NewArray(Of T)(ByVal ParamArray Args As T()) As T()
         Return Args
      End Function

      Public Function NewArray(Of T)(ByVal count As Integer) As T()
         Dim ret(count - 1) As T
         Return ret
      End Function

      Public Function NewList1(Of T)(ByVal First As T) As List(Of T)
         Return New List(Of T)(New T() {First})
      End Function

      Public Function NewList(Of T)(ByVal First As T, ByVal Second As T, ByVal ParamArray Entries As T()) As List(Of T)
         NewList = New List(Of T)(New T() {First, Second})
         NewList.AddRange(Entries)
      End Function

      Public Function NewList(Of T)(ByVal Entries As IEnumerable(Of T)) As List(Of T)
         Return New List(Of T)(Entries)
      End Function

      Public Function NewStack(Of T)(ByVal Entries As IEnumerable(Of T)) As Stack(Of T)
         Return New Stack(Of T)(Entries)
      End Function

      Public Function NewDictionary(Of T, T2)(ByVal Entries As IEnumerable(Of KeyValuePair(Of T, T2))) As Dictionary(Of T, T2)
         NewDictionary = New Dictionary(Of T, T2)
         For Each Itm In Entries
            NewDictionary.Add(Itm.Key, Itm.Value)
         Next
      End Function

      Public Function NewDictionary(Of T, T2)(ByVal ParamArray Entries() As KeyValuePair(Of T, T2)) As Dictionary(Of T, T2)
         NewDictionary = New Dictionary(Of T, T2)
         For Each Itm In Entries
            NewDictionary.Add(Itm.Key, Itm.Value)
         Next
      End Function

      Public Function NewKeyValue(Of TKey, TValue)(ByVal Key As TKey, ByVal Value As TValue) _
              As KeyValuePair(Of TKey, TValue)
         Return New KeyValuePair(Of TKey, TValue)(Key, Value)
      End Function


      Public Function NewSet(Of Ta)(ByVal a As Ta) As [Set](Of Ta)
         Return New [Set](Of Ta) With {.A = a}
      End Function
      Public Function NewSet(Of Ta, Tb)(ByVal a As Ta, ByVal b As Tb) As [Set](Of Ta, Tb)
         Return New [Set](Of Ta, Tb) With {.A = a, .B = b}
      End Function
      Public Function NewSet(Of Ta, Tb, Tc)(ByVal a As Ta, ByVal b As Tb, ByVal c As Tc) _
            As [Set](Of Ta, Tb, Tc)
         Return New [Set](Of Ta, Tb, Tc) With {.A = a, .B = b, .C = c}
      End Function
      Public Function NewSet(Of Ta, Tb, Tc, Td)( _
            ByVal a As Ta, ByVal b As Tb, ByVal c As Tc, ByVal d As Td) As [Set](Of Ta, Tb, Tc, Td)
         Return New [Set](Of Ta, Tb, Tc, Td) With {.A = a, .B = b, .C = c, .D = d}
      End Function
      Public Function NewSet(Of Ta, Tb, Tc, Td, Te)( _
            ByVal a As Ta, ByVal b As Tb, ByVal c As Tc, ByVal d As Td, ByVal e As Te) _
            As [Set](Of Ta, Tb, Tc, Td, Te)
         Return New [Set](Of Ta, Tb, Tc, Td, Te) With { _
            .A = a, .B = b, .C = c, .D = d, .E = e}
      End Function
      Public Function NewSet(Of Ta, Tb, Tc, Td, Te, Tf)( _
            ByVal a As Ta, ByVal b As Tb, ByVal c As Tc, ByVal d As Td, ByVal e As Te, ByVal f As Tf) _
            As [Set](Of Ta, Tb, Tc, Td, Te, Tf)
         Return New [Set](Of Ta, Tb, Tc, Td, Te, Tf) With { _
            .A = a, .B = b, .C = c, .D = d, .E = e, .F = f}
      End Function

   End Module
End Namespace
