﻿Imports System.IO
Imports System.ComponentModel

Namespace System.Data

   Public Class DatasetXmlAdapter : Inherits DatasetAdapterBase

      Public DataFile As FileInfo

      Public Sub New(ByVal _Dts As DataSet, ByVal path As String)
         DataFile = New FileInfo(path)
         DataSet = _Dts
      End Sub

      Protected Overrides Sub _Save(ByVal tbls As IEnumerable(Of DataTable))
         For Each att In TableAttachs(Persistance.No)
            att.Table.ClearRecursive()
         Next
         Synchronisize(FileAccess.Write)
      End Sub

      Protected Overrides Sub _Fill(ByVal tbls As Collections.Generic.IEnumerable(Of DataTable))
         If tbls.FirstOrDefault.NotNull Then Throw New NotSupportedException( _
               "Bei DatasetOnly werden immer alle Tabellen befüllt - bestimmte Tabellen anzugeben ist sinnlos")
         DataFile.Refresh()
         If DataFile.Exists() Then
            Dim tblls = _DataSet.Tables
            For Each tb As DataTable In DataSet.Tables
               tb.Attach.EnableComplete(False, True)
            Next
            _DataSet.Clear()
            Synchronisize(FileAccess.Read)
            For Each tb As DataTable In DataSet.Tables
               tb.Attach.EnableComplete(True, True)
            Next
            DataSet.EnforceConstraints = True 'tb.BeginLoadData setzt  EnforceConstraints.False 
         Else
            MsgBox(String.Concat( _
               "Leider (noch) kein DatenFile vorhanden", ControlChars.Lf, _
               "Sie können aber trotzdem fortfahren, und eines anlegen."))
         End If
      End Sub

      Private Sub Synchronisize(ByVal access As FileAccess)
         If DataFile.Extension.ToLower = ".txt" Then
            'If access = FileAccess.Read Then
            '   DataSet.LoadCompact(DataFile.FullName)
            'Else
            '   DataSet.SaveCompact(DataFile.FullName)
            'End If
         Else
            If access = FileAccess.Read Then
               DataSet.ReadXml(DataFile.FullName)
            Else
               DataSet.WriteXml(DataFile.FullName)
            End If
         End If
      End Sub

   End Class

End Namespace