﻿Imports NorthWind.NorthWindDts
Imports System.Data.OleDb

Public Class frmMain

   Private _TimeRanges As Integer() = New Integer() {99999, 1, 2, 3, 6, 9, 12}

   Private Sub frmNorthWind_Load(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Load
      NorthWindDts.CheckedCategory.Persist(False)
      'NorthWindDts.PersistAll()
      Dim adp = New DatasetAdapter( _
         OleDbFactory.Instance, My.Settings.BestellungPrimConnectionString, _
         ConflictOption.OverwriteChanges)
      Me.AlignOnTop.NorthWindDts.Adapter(adp).Register(Me)
      AddHandler Me.FormClosing, NorthWindDts.HandleFormClosing
      cmbOrderRange.DataSource = _TimeRanges
      Reload()
   End Sub

   Private Sub MenuItem_Click(ByVal sender As Object, ByVal e As EventArgs) _
         Handles ReloadToolStripMenuItem.Click, SaveToolStripMenuItem.Click, TestToolStripMenuItem.Click, ReFillStoreToolStripMenuItem.Click
      Select Case True
         Case sender Is ReloadToolStripMenuItem : Reload()
         Case sender Is SaveToolStripMenuItem : NorthWindDts.Save(Me)
         Case sender Is TestToolStripMenuItem : Test()
         Case sender Is ReFillStoreToolStripMenuItem
            Using frm = New frmRefillStore
               frm.ShowDialog(Me)
            End Using
      End Select
   End Sub

   Private Sub SelectLastOrders()
      'ermittelt von allen Kunden die jeweils letzte Bestellung
      NorthWindDts.Bestellungen.Fill(" where Bestelldatum = (select max(Bestelldatum) from Bestellungen as b2 where Bestellungen.KundeID= b2.KundeID)")
   End Sub

   Private Sub Test()
      If True Then 'only first Case gets executed
         KategorienBindingSource.FilterX("Kategoriename LIKE ?", "ge*")
         Return
      ElseIf True Then
         NorthWindDts.Kategorien.Fill("where Kategoriename LIKE ?", "ge%")
      ElseIf True Then
         SelectLastOrders()
         Return
      ElseIf True Then
         NorthWindDts.Kategorien.Fill("where kategorieID in (?,?)", 1, 4)
      ElseIf True Then
         ' achtung! zur korrekten Ergebnis-Anzeige muß die dynamische Befüllung auf
         '°Komplettbefüllung umgestellt wern: (in Reload: NorthwindDts.Fill() +
         '°KundenBindingSource_CurrentChanged abhängen)
         Dim joiner As New Joiner()
         ' alle Bestellungen mit Artikel 1 **und** 2
         ' korrekt formuliert: alle Bestellungen, die BestellDetails enthalten, von denen eines
         '°auf Art 1 verweist, **und** ein anneres auf Art 2
         joiner.Add(NorthWindDts.Bestelldetails.BestellIDColumn, "ArtikelID=?")
         joiner.SelfJoin(NorthWindDts.Bestelldetails.BestellIDColumn, "ArtikelID=?")
         NorthWindDts.Bestellungen.Fill(joiner.Sql, 1, 2)

         'kunden ausgeben, die das bestellt haben
         Dbg(" ".Between(From bst In NorthWindDts.Bestellungen Select bst.KundeID))

         ' alle Bestelldetails  dieser Bestellungen
         ' korrekt formuliert: alle BestellDetails, die in Bestellungen enthalten sind, die
         '°BestellDetails enthalten, von denen eines auf Art 1 verweist, und ein anneres auf Art 2
         Dim n = NorthWindDts.Bestellungen.Rows.Count
         joiner.Clear()
         joiner.SelfJoin(NorthWindDts.Bestelldetails.BestellIDColumn, "ArtikelID=?")
         joiner.SelfJoin(NorthWindDts.Bestelldetails.BestellIDColumn, "ArtikelID=?")
         NorthWindDts.Bestelldetails.Fill(joiner.Sql, 1, 2)
         Return
      ElseIf True Then
         NorthWindDts.Kategorien.Fill("where mid(Kategoriename, 2, 1)= ?", "e")
      ElseIf True Then
         NorthWindDts.Kategorien.Fill("where KategorieID between ? and ?", 1, 5)
      ElseIf True Then
      End If

      MsgBox(String.Join(vbNewLine, New String() { _
         "Durch diesen Test wurde Kategorien neu befüllt, nicht aber Artikel.", _
         "Daher sind alle Artikel gelöscht, und dadurch auch alle BestellDetails.", _
         "Wenn man nun einen anneren Kunden anwählt, so werden ja dessen Bestellungen nachgeladen, und auch deren Bestelldetails (normale Funktionalität des Progs).", _
         "Aber die nachgeladenen BestellDetails verweisen dann z.T. auf Artikel, dies nicht mehr gibt.", _
         "Folge: Crash.", _
         "Ist ja nur ein test, ob der Sql-Ausdruck funzt.", _
         "", _
         "Dasser funzt, sieht man auf dem 'Artikel'-Tab ;)"}))
   End Sub

   Private Sub Reload()
      With NorthWindDts
         .Fill(.Artikel, .Kategorien, .Kunden)
      End With
   End Sub

   Private Sub KundenBindingSource_CurrentChanged(ByVal sender As Object, ByVal e As EventArgs) _
         Handles KundenBindingSource.CurrentChanged
      Dim rwKunde = KundenBindingSource.At(Of KundenRow)()
      If rwKunde.Null Then Return
      With NorthWindDts
         rwKunde.FillChildTables(.Bestellungen, .Bestelldetails)
      End With
      SetOrderFilter()
   End Sub

   Private Sub SetOrderFilter()
      If cmbOrderRange.SelectedIndex < 0 Then Return
      Dim filter = ""
      Try
         If NorthWindDts.Bestellungen.Count = 0 Then Exit Sub
         Dim dt = NorthWindDts.Bestellungen.Max(Function(r) r.Bestelldatum)
         Dim nMonth = _TimeRanges(cmbOrderRange.SelectedIndex)
         If Date.MinValue.AddMonths(nMonth) > dt Then
            Exit Sub 'die nachfolgende Rechnung ergäbe einen Wert < Minvalue - Fehler
         End If
         filter = "Bestelldatum > ".And("'", dt.AddMonths(-nMonth).ToShortDateString, "'")
      Finally
         srcKundeBestellung.Filter = filter
         lbFilter.Text = filter
      End Try
   End Sub

   Private Sub cmbOrderRange_SelectedIndexChanged(ByVal sender As Object, ByVal e As EventArgs) Handles cmbOrderRange.SelectedIndexChanged
      SetOrderFilter()
   End Sub

End Class