﻿#If NoCompile Then
Dieses Form zeigt eine einfache Extension, mit der man maximal einfach Commands erstellen kann, unter Verwendung von DbParametern. Die Methode ist im kleinen Modul ganz am Ende diser Datei.
Insgesamt halte ich nix davon, überhaupt Commands zu erstellen, ausser als Komponente eines DataAdapters. Aber um in Foren den StringFricklern eine Alternative bieten zu können habe ich mal dieses Sample gecodet.
Ausführlich dazu: http://www.vb-paradise.de/allgemeines/tipps-tricks-und-tutorials/datenbanken/73957-tipp-trick-dbparameter/#post598805
#End If

Imports System.Data.SqlServerCe

Public Class frmOhneDataset
   Private _Con As New SqlCeConnection(My.Settings.BestellungenConnectionString)

   Private Sub frmOhneDataset_Load(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Load
      Me.AlignOnTop()
   End Sub

   Private Sub LadeKundenToolStripMenuItem_Click(ByVal sender As Object, ByVal e As EventArgs) Handles LadeKundenToolStripMenuItem.Click, LadeBearbeiterToolStripMenuItem.Click, LadeBestellungenToolStripMenuItem.Click, btLadeGefiltert.Click, ClearAllToolStripMenuItem.Click
      Select Case True
         Case sender Is LadeKundenToolStripMenuItem
            LadeKunden()
         Case sender Is LadeBearbeiterToolStripMenuItem
            LadeBearbeiter()
         Case sender Is LadeBestellungenToolStripMenuItem
            LadeBestellungen()
         Case sender Is ClearAllToolStripMenuItem
            For Each lv In New ListView() {lvKunde, lvBearb, lvBest}
               lv.Items.Clear()
            Next
         Case sender Is btLadeGefiltert
            LadeBestellungenGefiltert()
      End Select
   End Sub

   Private Sub LadeKunden()
      _Con.Open()
      Using cmd = _Con.CreateCommandX("Select * From [Kunde]"), rd = cmd.ExecuteReader
         While rd.Read
            Dim lvi = lvKunde.Items.Add(rd(0).ToString)
            For i = 1 To rd.VisibleFieldCount - 1
               lvi.SubItems.Add(rd(i).ToString)
            Next
         End While
      End Using
      _Con.Close()
   End Sub

   Private Sub LadeBearbeiter()
      _Con.Open()
      Using cmd = _Con.CreateCommandX("Select * From [Bearbeiter]"), rd = cmd.ExecuteReader
         While rd.Read
            Dim lvi = lvBearb.Items.Add(rd(0).ToString)
            For i = 1 To rd.VisibleFieldCount - 1
               lvi.SubItems.Add(rd(i).ToString)
            Next
         End While
      End Using
      _Con.Close()
   End Sub

   Private Sub LadeBestellungen()
      _Con.Open()
      Using cmd = _Con.CreateCommandX("Select * From [Bestellung]"), rd = cmd.ExecuteReader
         While rd.Read
            Dim lvi = lvBest.Items.Add(rd(0).ToString)
            For i = 1 To rd.VisibleFieldCount - 1
               lvi.SubItems.Add(rd(i).ToString)
            Next
         End While
      End Using
      _Con.Close()
   End Sub

   Private Sub LadeBestellungenGefiltert()
      _Con.Open()
      Using cmd = _Con.CreateCommandX( _
            "Select * From [Bestellung] where [Datum] between ? and ?", dtpVon.Value, dtBis.Value), _
            rd = cmd.ExecuteReader
         While rd.Read
            Dim lvi = lvBest.Items.Add(rd(0).ToString)
            For i = 1 To rd.VisibleFieldCount - 1
               lvi.SubItems.Add(rd(i).ToString)
            Next
         End While
      End Using
      _Con.Close()
   End Sub

   Private Sub NoGo()
      'würde vmtl. crashen, weil die Datumse automatisch konvertiert würden, und zwar falsch.
      'Aber normale NoGo-Progger verwenden eh Textboxen, sodass Angreifer dort ihre Sql-Injection-Angriffe reinschreiben können.
      Dim sql = "Select * From [Bestellung] where [Datum] between " & dtpVon.Value & " and " & dtBis.Value
      Dim cmd = New SqlCeCommand(sql, _Con)
      '...
   End Sub

   Private Sub UmständlichUndAnfällig()
      'etwas umständlich, weil zw. Command erstellen und Command abfahren noch die Parameter geaddet wern müssen
      'etwas anfällig, weil die Parameternamen zweimal identisch festgelegt werden müssen.
      Dim sql = "Select * From [Bestellung] where [Datum] between @von and @bis"
      _Con.Open()
      Using cmd = New SqlCeCommand(sql, _Con)
         'DBParameter vereiteln Sql-Injection und konvertieren i.a. typ-richtig
         cmd.Parameters.AddWithValue("@von", dtpVon.Value)
         cmd.Parameters.AddWithValue("@bis", dtBis.Value)
         Using rd = cmd.ExecuteReader
            While rd.Read
               Dim lvi = lvBest.Items.Add(rd(0).ToString)
               For i = 1 To rd.VisibleFieldCount - 1
                  lvi.SubItems.Add(rd(i).ToString)
               Next
            End While
         End Using
      End Using
      _Con.Close()
   End Sub

End Class

Public Module SqlCeExtensions

   ''' <summary>
   ''' allgemeine Methode, aus einer SqlCeConnection, einem CommandText und optionalen Werten ein parametrisiertes SqlCeCommand zu erstellen
   ''' </summary>
   <Runtime.CompilerServices.Extension()> _
   Public Function CreateCommandX(ByVal con As SqlCeConnection, ByVal commandText As String, ByVal ParamArray values As Object()) As SqlCeCommand
      Dim splits = commandText.Split("?"c)
      If splits.Count <> values.Length + 1 Then Throw New ArgumentException( _
         "Anzahl der Argumente passt nicht zur Anzahl der Parameter-Platzhalter im CommandText")
      Dim cmd = New SqlCeCommand()
      For i = 0 To values.Length - 1
         Dim param = cmd.Parameters.AddWithValue("@a" & i, values(i))
         splits(i) = splits(i) & param.ParameterName
      Next
      cmd.CommandText = String.Concat(splits)
      cmd.Connection = con
      Return cmd
   End Function
End Module