﻿Imports SqlServerTest.NorthwindDts
Imports System.Data.OleDb
Imports System.Data.SqlClient

Public Class frmSqlSrv

   Private _TimeRanges As Integer() = New Integer() {99999, 1, 2, 3, 6, 9, 12}

   Private Sub frmNorthWind_Load(ByVal sender As Object, ByVal e As EventArgs) Handles MyBase.Load
      Dim adp = New DatasetAdapter( _
         SqlClientFactory.Instance, My.Settings.NORTHWNDConnectionString, _
         ConflictOption.OverwriteChanges)
      Me.AlignOnTop.NorthwindDts.Adapter(adp).Register(Me)
      AddHandler Me.FormClosing, NorthwindDts.HandleFormClosing
      cmbOrderRange.DataSource = _TimeRanges
      Reload()
   End Sub

   Private Sub Button_Click(ByVal sender As Object, ByVal e As EventArgs) _
         Handles ReloadToolStripMenuItem.Click, SaveToolStripMenuItem.Click, _
         TestToolStripMenuItem.Click, btAddProduct.Click, btCancelEdit.Click, btDelete.Click
      Select Case True
         Case sender Is ReloadToolStripMenuItem : Reload()

         Case sender Is SaveToolStripMenuItem
            ProductsBindingSource.EndEdit()
            NorthwindDts.Save(Me)

         Case sender Is TestToolStripMenuItem
            NorthwindDts.Customers.Fill("where customerID like ?", "AN%")

         Case sender Is btAddProduct
            With ProductsBindingSource.AddNewX(Of ProductsRow)()
               .SupplierID = 1
            End With

         Case sender Is btCancelEdit : ProductsBindingSource.CancelEdit()

         Case sender Is btDelete : ProductsBindingSource.RemoveCurrent()

      End Select
   End Sub

   Private Sub Reload()
      With NorthwindDts
         .Fill(.Products, .Categories, .Customers)
      End With
   End Sub

   Private Sub CustomersBindingSource_CurrentChanged(ByVal sender As Object, ByVal e As EventArgs) _
         Handles CustomersBindingSource.CurrentChanged
      Dim rw = CustomersBindingSource.At(Of CustomersRow)()
      If rw.Null Then Return
      With NorthwindDts
         rw.FillChildTables(.Orders, .Order_Details)
      End With
      SetOrderFilter()
   End Sub

   Private Sub SetOrderFilter()
      If cmbOrderRange.SelectedIndex < 0 Then Return
      Dim n = _TimeRanges(cmbOrderRange.SelectedIndex)
      Dim filter = ""
      Try
         If NorthwindDts.Orders.Count = 0 Then Exit Sub
         Dim dt = NorthwindDts.Orders.Max(Function(r) r.OrderDate)
         If Date.MinValue.AddMonths(n) > dt Then
            Exit Sub 'die nachfolgende Rechnung ergäbe einen Wert < Minvalue - Fehler
         End If
         filter = "OrderDate > ".And("'", dt.AddMonths(-n).ToShortDateString, "'")
      Finally
         srcCustomerOrder.Filter = filter
         lbFilter.Text = filter
      End Try
   End Sub

   Private Sub cmbOrderRange_SelectedIndexChanged(ByVal sender As Object, ByVal e As EventArgs) Handles cmbOrderRange.SelectedIndexChanged
      SetOrderFilter()
   End Sub
End Class